# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ainstein_radar_msgs/RadarInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class RadarInfo(genpy.Message):
  _md5sum = "517f7ed5e498f66b6af3caaa2c6f2059"
  _type = "ainstein_radar_msgs/RadarInfo"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# This message defines meta information for a radar sensor. It should
# be in a radar namespace on topic "radar_info" and accompanied by up
# to three radar topics named:
#
#   targets/raw      - raw (untracked) radar detections
#   targets/tracked  - tracked radar detections
#   alarms           - alarms based on detections, eg BSD
#
# In general, all Ainstein radars output raw detections and may also
# output tracked detections if trackign algorithms are implemented in
# firmware. Tracking from raw data is also available in ROS; see the
# ainstein_radar_filters package for more information. Most radars do
# not output alarms as this is specific to the automotive use case,
# however this message type is retained for the time being for backward
# compatibility.

#######################################################################
#                     Data acquisition info                           #
#######################################################################

# Time of data acquisition, radar coordinate frame ID
Header header    # Header timestamp should be acquisition time of data
                 # Header frame_id should be radar sensing frame
                 # origin of frame should be center of sensor
                 # +x should point radially outwards from the radar
                 # +y should point to complete a right-handed frame
                 # +z should point upwards

#######################################################################
#                    General sensor properties                        #
#######################################################################

# The nominal update rate of the sensor reported in Hz.
float64 update_rate

# The maximum number of detections (targets) the sensors can report.
uint16 max_num_targets

#######################################################################
#                    Physical sensing limits                          #
#######################################################################
# These are limits imposed by the antenna hardware and/or cutoffs set #
# in the detection processing firmware. They come from sensor data    #
# sheets and must be updated with each hardware revision as necessary.#
#######################################################################

# The minimum and maximum range, in meters, of detections (targets)
# reported by the sensor.
float64 range_min
float64 range_max

# The minimum and maximum speed, in meters per second, of detections
# (targets) reported by the sensor.
float64 speed_min
float64 speed_max

# The minimum and maximum azimuth angle, in degrees.
float64 azimuth_min
float64 azimuth_max

# The minimum and maximum azimuth angle, in degrees.
float64 elevation_min
float64 elevation_max

#######################################################################
#                    Physical sensing precision                       #
#######################################################################
# These are also imposed by the antenna hardware and/or set in the    #
# detection processing firmware. They also come from sensor data      #
# sheets and must be updated with each hardware revision as necessary.#
#######################################################################

# Range resolution, in meters. The resolution is defined as the minimum
# distance between two objects which results in distinct detections.
float64 range_resolution

# Range accuracy, in meters. The accuracy is defined as the precision
# with which range of a detection is reported.
float64 range_accuracy

# Speed resolution, in meters per second. The resolution is defined as
# the minimum speed difference between two objects which results in
# distinct detections.
float64 speed_resolution

# Speed accuracy, in meters per second. The accuracy is defined as the
# precision with which speed of a detection is reported.
float64 speed_accuracy

# Azimuth angle resolution, in degrees. The resolution is defined as
# the minimum azimuth angle between two objects which results in
# distinct detections.
float64 azimuth_resolution

# Azimuth angle accuracy, in degrees. The accuracy is defined as the
# precision with which the azimuth angle of a detection is reported.
float64 azimuth_accuracy

# Elevation angle resolution, in degrees. The resolution is defined as
# the minimum elevation angle between two objects which results in
# distinct detections.
float64 elevation_resolution

# Elevation angle accuracy, in degrees. The accuracy is defined as the
# precision with which the elevation angle of a detection is reported.
float64 elevation_accuracy

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['header','update_rate','max_num_targets','range_min','range_max','speed_min','speed_max','azimuth_min','azimuth_max','elevation_min','elevation_max','range_resolution','range_accuracy','speed_resolution','speed_accuracy','azimuth_resolution','azimuth_accuracy','elevation_resolution','elevation_accuracy']
  _slot_types = ['std_msgs/Header','float64','uint16','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,update_rate,max_num_targets,range_min,range_max,speed_min,speed_max,azimuth_min,azimuth_max,elevation_min,elevation_max,range_resolution,range_accuracy,speed_resolution,speed_accuracy,azimuth_resolution,azimuth_accuracy,elevation_resolution,elevation_accuracy

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.update_rate is None:
        self.update_rate = 0.
      if self.max_num_targets is None:
        self.max_num_targets = 0
      if self.range_min is None:
        self.range_min = 0.
      if self.range_max is None:
        self.range_max = 0.
      if self.speed_min is None:
        self.speed_min = 0.
      if self.speed_max is None:
        self.speed_max = 0.
      if self.azimuth_min is None:
        self.azimuth_min = 0.
      if self.azimuth_max is None:
        self.azimuth_max = 0.
      if self.elevation_min is None:
        self.elevation_min = 0.
      if self.elevation_max is None:
        self.elevation_max = 0.
      if self.range_resolution is None:
        self.range_resolution = 0.
      if self.range_accuracy is None:
        self.range_accuracy = 0.
      if self.speed_resolution is None:
        self.speed_resolution = 0.
      if self.speed_accuracy is None:
        self.speed_accuracy = 0.
      if self.azimuth_resolution is None:
        self.azimuth_resolution = 0.
      if self.azimuth_accuracy is None:
        self.azimuth_accuracy = 0.
      if self.elevation_resolution is None:
        self.elevation_resolution = 0.
      if self.elevation_accuracy is None:
        self.elevation_accuracy = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.update_rate = 0.
      self.max_num_targets = 0
      self.range_min = 0.
      self.range_max = 0.
      self.speed_min = 0.
      self.speed_max = 0.
      self.azimuth_min = 0.
      self.azimuth_max = 0.
      self.elevation_min = 0.
      self.elevation_max = 0.
      self.range_resolution = 0.
      self.range_accuracy = 0.
      self.speed_resolution = 0.
      self.speed_accuracy = 0.
      self.azimuth_resolution = 0.
      self.azimuth_accuracy = 0.
      self.elevation_resolution = 0.
      self.elevation_accuracy = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_dH16d().pack(_x.update_rate, _x.max_num_targets, _x.range_min, _x.range_max, _x.speed_min, _x.speed_max, _x.azimuth_min, _x.azimuth_max, _x.elevation_min, _x.elevation_max, _x.range_resolution, _x.range_accuracy, _x.speed_resolution, _x.speed_accuracy, _x.azimuth_resolution, _x.azimuth_accuracy, _x.elevation_resolution, _x.elevation_accuracy))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 138
      (_x.update_rate, _x.max_num_targets, _x.range_min, _x.range_max, _x.speed_min, _x.speed_max, _x.azimuth_min, _x.azimuth_max, _x.elevation_min, _x.elevation_max, _x.range_resolution, _x.range_accuracy, _x.speed_resolution, _x.speed_accuracy, _x.azimuth_resolution, _x.azimuth_accuracy, _x.elevation_resolution, _x.elevation_accuracy,) = _get_struct_dH16d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_dH16d().pack(_x.update_rate, _x.max_num_targets, _x.range_min, _x.range_max, _x.speed_min, _x.speed_max, _x.azimuth_min, _x.azimuth_max, _x.elevation_min, _x.elevation_max, _x.range_resolution, _x.range_accuracy, _x.speed_resolution, _x.speed_accuracy, _x.azimuth_resolution, _x.azimuth_accuracy, _x.elevation_resolution, _x.elevation_accuracy))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 138
      (_x.update_rate, _x.max_num_targets, _x.range_min, _x.range_max, _x.speed_min, _x.speed_max, _x.azimuth_min, _x.azimuth_max, _x.elevation_min, _x.elevation_max, _x.range_resolution, _x.range_accuracy, _x.speed_resolution, _x.speed_accuracy, _x.azimuth_resolution, _x.azimuth_accuracy, _x.elevation_resolution, _x.elevation_accuracy,) = _get_struct_dH16d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_dH16d = None
def _get_struct_dH16d():
    global _struct_dH16d
    if _struct_dH16d is None:
        _struct_dH16d = struct.Struct("<dH16d")
    return _struct_dH16d
